//-----------------------------------------------------------------
#property copyright "http://www.forex-tsd.com"
#property link      "http://www.forex-tsd.com"
#property indicator_separate_window
#property indicator_buffers    2
#property indicator_color1     LimeGreen
#property indicator_color2     Gold
#property indicator_width1     2
#property indicator_levelcolor MediumOrchid

//
//
//
//
//

extern string TimeFrame        = "Current time frame";
extern int    pq               = 2;
extern int    pr               = 10;
extern int    ps               = 5;
extern int    trigger          = 3;
extern double OverSold         = -200;
extern double OverBought       = 200;

extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsNotify     = true;
extern bool   alertsEmail      = true;
extern string soundFile        = "alert2.wav"; 

extern bool   ShowArrows       = false;
extern string arrowsIdentifier = "Ergodic CCI Arrows";
extern double arrowsUpperGap   = 0.5;
extern double arrowsLowerGap   = 0.5;

extern color  arrowsUpColor    = LimeGreen;
extern color  arrowsDnColor    = Red;
extern color  arrowsNuColor    = Gray;
extern color  arrowsUpCode     = 241;
extern color  arrowsDnCode     = 242;
extern color  arrowsNuCode     = 108;

//
//
//
//
//

double ErgoCCI[];
double MainCCI[];
double trend[];
string indicatorFileName;
bool   returnBars;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,ErgoCCI);   SetIndexLabel(0,"Egodic CCI");
   SetIndexBuffer(1,MainCCI);   SetIndexLabel(1,"Trigger Line");
   SetIndexBuffer(2,trend); 
   SetLevelValue(0,OverBought);
   SetLevelValue(1,OverSold);
   SetLevelValue(2,0);
      timeFrame         = stringToTimeFrame(TimeFrame);
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame == "returnBars"; if (returnBars) return(0);
   return(0);
}

int deinit()
{
   deleteArrows();
    
return(0);
}

//
//
//
//
//

int start()
{
   string signal;
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { ErgoCCI[0] = limit+1; return(0); }
         if (timeFrame!=Period())
         {
            limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
            for (int i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,timeFrame,Time[i]);               
                  ErgoCCI[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",pq,pr,ps,trigger,0,y);
                  MainCCI[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",pq,pr,ps,trigger,1,y);
                  trend[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",pq,pr,ps,trigger,2,y);
                  manageArrow(i);
            }
            manageAlerts();
            return(0);                  
         }

   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      double var1  = iEma(iEma(iEma(        Close[i]-Close[i+1] ,pq,i,0),pr,i,1),ps,i,2);
      double var2  = iEma(iEma(iEma(MathAbs(Close[i]-Close[i+1]),pq,i,3),pr,i,4),ps,i,5);
         if (var2 != 0)
               ErgoCCI[i] = 500.0 * var1/var2;
         else  ErgoCCI[i] = 0;
               MainCCI[i] = iEma(ErgoCCI[i],trigger,i,6);
               
               trend[i] = 0;
               if (MainCCI[i] >  ErgoCCI[i]) trend[i] =-1;
               if (MainCCI[i] <  ErgoCCI[i]) trend[i] = 1;
               if (MainCCI[i] == ErgoCCI[i]) trend[i] = 0;
               manageArrow(i);
   }
   if (MainCCI[0] >  ErgoCCI[0]) signal = "SHORT";
   if (MainCCI[0] <  ErgoCCI[0]) signal = "LONG";
   if (MainCCI[0] == ErgoCCI[0]) signal = "NEUTRAL";
      IndicatorShortName(timeFrameToString(timeFrame)+" FX Sniper's Ergodic CCI & Trigger: "+signal);
   manageAlerts();
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workEma[][7];
double iEma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workEma,0)!= Bars) ArrayResize(workEma,Bars); r=Bars-r-1;

   //
   //
   //
   //
   //
      
   double alpha = 2.0 / (1.0+period);
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+alpha*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar)); 
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1)                          doAlert(whichBar,"Buy");
         if (trend[whichBar] ==-1)                          doAlert(whichBar,"Sell");
         if (trend[whichBar] == 0 && trend[whichBar+1]== 1) doAlert(whichBar,"back from up now neutral");
         if (trend[whichBar] ==-0 && trend[whichBar+1]==-1) doAlert(whichBar,"back from down now neutral");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

           message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Ergodic CCI ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," Ergodic CCI " +" "+message));
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " Ergodic CCI "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageArrow(int i)
{
   if (ShowArrows)
   {
      deleteArrow(Time[i]);
      if (trend[i]!=trend[i+1])
      {
         if (trend[i] == 1)                   drawArrow(i,arrowsUpColor,arrowsUpCode,false);
         if (trend[i] ==-1)                   drawArrow(i,arrowsDnColor,arrowsDnCode, true);
         if (trend[i] == 0 && trend[i+1]== 1) drawArrow(i,arrowsNuColor,arrowsNuCode,false);
         if (trend[i] == 0 && trend[i+1]==-1) drawArrow(i,arrowsNuColor,arrowsNuCode, true);
      }
   }
}               

//
//
//
//
//

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

